/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.npc.CreateNpcInfoUniverse
 *  fire.msp.npc.MRemoveNpcFromGS
 *  fire.msp.npc.MUpdateNpcInfo
 *  fire.msp.npc.NpcInfo
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.SNpcShare
 *  fire.pb.scene.MapUtil
 *  fire.pb.scene.Scene
 *  fire.pb.scene.SceneClient
 *  fire.pb.scene.SceneManager
 *  fire.pb.scene.config.NpcDesc
 *  fire.pb.scene.movable.God
 *  fire.pb.scene.movable.Monstershow
 *  fire.pb.scene.movable.NPC
 *  fire.pb.scene.sPos.BasicPos
 *  fire.pb.scene.sPos.GridPos
 *  fire.pb.scene.sPos.Position
 *  fire.pb.school.School
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.ProfessionLeaderInfo
 *  xbean.Properties
 *  xtable.Professionleader
 *  xtable.Properties
 */
package fire.pb.scene.manager;

import fire.msp.npc.CreateNpcInfoUniverse;
import fire.msp.npc.MRemoveNpcFromGS;
import fire.msp.npc.MUpdateNpcInfo;
import fire.msp.npc.NpcInfo;
import fire.pb.main.ConfigManager;
import fire.pb.npc.SNpcShare;
import fire.pb.scene.MapUtil;
import fire.pb.scene.Scene;
import fire.pb.scene.SceneClient;
import fire.pb.scene.SceneManager;
import fire.pb.scene.config.NpcDesc;
import fire.pb.scene.manager.GatherManager;
import fire.pb.scene.manager.MonstershowManager;
import fire.pb.scene.movable.God;
import fire.pb.scene.movable.Monstershow;
import fire.pb.scene.movable.NPC;
import fire.pb.scene.sPos.BasicPos;
import fire.pb.scene.sPos.GridPos;
import fire.pb.scene.sPos.Position;
import fire.pb.school.School;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.NavigableMap;
import java.util.TreeMap;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.ProfessionLeaderInfo;
import xtable.Professionleader;
import xtable.Properties;

public class SceneNpcManager {
    public static final Logger logger = Logger.getLogger((String)"MAPMAIN");
    private static volatile SceneNpcManager instance;
    public NavigableMap<Long, NPC> npcs = new TreeMap<Long, NPC>();
    private long nextkey = 0L;

    private SceneNpcManager() {
    }

    public static SceneNpcManager getInstance() {
        if (null == instance && null == instance) {
            instance = new SceneNpcManager();
        }
        return instance;
    }

    private boolean addSceneNpc(NPC npc) {
        if (npc == null) {
            return false;
        }
        for (School school : School.values()) {
            xbean.Properties prop;
            ProfessionLeaderInfo leader;
            int npcid = school.getNpcid();
            if (npcid != npc.getNpcID() || (leader = Professionleader.select((Integer)school.getValue())) == null || (prop = Properties.select((Long)leader.getRoleid())) == null) continue;
            npc.setName(prop.getRolename());
            npc.setShape(prop.getShape());
            for (Map.Entry entry : leader.getShapecomponent().entrySet()) {
                if (entry == null) continue;
                int type = (Integer)entry.getKey();
                int value = (Integer)entry.getValue();
                npc.components.put((byte)type, value);
            }
        }
        if (this.npcs.containsKey(npc.getUniqueID())) {
            return false;
        }
        this.npcs.put(npc.getUniqueID(), npc);
        return true;
    }

    private boolean removeSceneNpc(NPC npc) {
        if (npc == null) {
            return false;
        }
        NPC rmvNpc = (NPC)this.npcs.remove(npc.getUniqueID());
        if (rmvNpc == null) {
            SceneManager.logger.error((Object)("remove npc from scene manager failed.npckey:" + npc.getUniqueID() + "npcid:" + npc.getNpcID()));
        }
        return true;
    }

    public boolean delNpcWhileDestroyScene(long npckey) {
        this.npcs.remove(npckey);
        return true;
    }

    public long getNextId() {
        ++this.nextkey;
        return this.nextkey;
    }

    public NPC getNpcByKey(Long key) {
        return (NPC)this.npcs.get(key);
    }

    public List<NPC> getNpcByID(Integer npcid) {
        ArrayList<NPC> res = new ArrayList<NPC>();
        for (NPC npc : this.npcs.values()) {
            if (npc.getNpcID() != npcid.intValue()) continue;
            res.add(npc);
        }
        return res;
    }

    public NPC createNpc(int npcid, String name, int dir) {
        long npckey = this.getNextId();
        return this.createNpcWithKey(npckey, npcid, name, dir);
    }

    public NPC createNpc(int npcid, String name, int dir, long npcKey) {
        return this.createNpcWithKey(npcKey, npcid, name, dir);
    }

    public NPC createNpcWithKey(long npckey, int npcid, String name, int dir) {
        SNpcShare conf = (SNpcShare)ConfigManager.getInstance().getConf(SNpcShare.class).get(npcid);
        if (conf != null && conf.npctype == 5) {
            return GatherManager.getInstance().genGathernpc(npckey, npcid, name, dir);
        }
        if ((name == null || name.equals("")) && conf != null) {
            name = conf.getName();
        }
        return God.createNPC((long)npckey, (int)npcid, (String)name, null, null, (int)dir);
    }

    public boolean summonNpc(Scene s, Position p, NPC npc) {
        if (null == s) {
            return false;
        }
        if (npc == null) {
            return false;
        }
        if (!s.validPosition(p)) {
            logger.error((Object)("NPC" + npc.getNpcID() + "在地图" + s.getMapID() + "的外面，坐标" + p.toGridPos()));
            return false;
        }
        npc.setScene(s);
        SNpcShare npcshare = (SNpcShare)ConfigManager.getInstance().getConf(SNpcShare.class).get(npc.getNpcID());
        Position finalp = new Position(p.getX(), p.getY(), npcshare.zPos);
        npc.setPos(finalp);
        if (SceneNpcManager.getInstance().addSceneNpc(npc)) {
            npc.enterMyScreen();
            return true;
        }
        logger.error((Object)("summonnpc failed.scene:" + s + "position:" + p.toGridPos() + "npcid:" + npc.getNpcID() + "npckey:" + npc.getNpcKey()));
        return false;
    }

    public boolean summonNpcAndUpdateGS(Scene s, Position p, NPC npc) {
        return this.summonNpcAndUpdateGS(s, p, npc, 0L);
    }

    public boolean summonNpcAndUpdateGS(Scene s, Position p, NPC npc, long time) {
        if (this.summonNpc(s, p, npc)) {
            MUpdateNpcInfo mUpdateNpcInfo = new MUpdateNpcInfo();
            NpcInfo npcinfo = new NpcInfo();
            npcinfo.mapid = npc.getScene().getMapID();
            npcinfo.name = npc.getName();
            npcinfo.shape = npc.getShape();
            npcinfo.npcbaseid = npc.getNpcID();
            npcinfo.npckey = npc.getUniqueID();
            npcinfo.posx = npc.getPos().getX();
            npcinfo.posy = npc.getPos().getY();
            npcinfo.posz = npc.getPos().getZ();
            npcinfo.sceneid = npc.getScene().getSceneID();
            npcinfo.time = time;
            mUpdateNpcInfo.npcs.add(npcinfo);
            SceneClient.pSend((Protocol)mUpdateNpcInfo);
            return true;
        }
        return false;
    }

    public boolean removeNpcFromScene(long npckey, String trace) {
        NPC npc = SceneNpcManager.getInstance().getNpcByKey(npckey);
        if (npc == null) {
            return false;
        }
        Scene ns = npc.getScene();
        if (null == ns) {
            return false;
        }
        if (npc.getNpcID() == 161301 || npc.getNpcID() == 161302 || npc.getNpcID() == 161303 || npc.getNpcID() == 161304) {
            logger.info((Object)new StringBuilder().append("remove npc from scene.npckey:").append(npckey).append(",npcid:").append(npc.getNpcID()).append(",trace:").append(trace));
        }
        npc.leaveMyScreen();
        SceneNpcManager.getInstance().removeSceneNpc(npc);
        if (npc instanceof Monstershow && MonstershowManager.getInstance().remove(npckey)) {
            new Exception("remove npcerror").printStackTrace();
        }
        MRemoveNpcFromGS mRemoveNpcFromGS = new MRemoveNpcFromGS();
        mRemoveNpcFromGS.trace = trace;
        mRemoveNpcFromGS.npckey = npckey;
        SceneClient.pSend((Protocol)mRemoveNpcFromGS);
        return true;
    }

    public boolean summonNpc(Scene s, NpcDesc npc) {
        if (npc == null) {
            return false;
        }
        NPC mapnpc = this.createNpc(npc.getid(), "", npc.getdir());
        return this.summonNpc(s, npc.getPos(), mapnpc);
    }

    public NPC summonNpcAndUpdateGS(Scene s, NpcDesc npc) {
        if (npc == null) {
            return null;
        }
        NPC mapnpc = this.createNpc(npc.getid(), "", npc.getdir());
        boolean succ = this.summonNpcAndUpdateGS(s, npc.getPos(), mapnpc, 0L);
        if (succ) {
            return mapnpc;
        }
        return null;
    }

    public boolean hasNpcInGridPos(GridPos pos, long sceneid) {
        Scene scene = SceneManager.getInstance().getSceneByID(sceneid);
        if (null == scene) {
            return true;
        }
        int index = scene.getScreenIndex(pos.toPosition());
        for (NPC n : scene.getNpcsInScreen(index).values()) {
            if (n.getPos().toGridPos().getDistance((BasicPos)pos) >= 8) continue;
            return true;
        }
        return false;
    }

    public List<NpcInfo> createNpc(CreateNpcInfoUniverse info) {
        if (info.num <= 0) {
            return null;
        }
        LinkedList<NpcInfo> npclist = new LinkedList<NpcInfo>();
        Object s = null;
        s = info.ownerid == 0L ? SceneManager.getInstance().getSceneByID((long)info.mapid) : SceneManager.getInstance().getSceneByMapAndOwner(info.mapid, info.ownerid);
        if (s == null) {
            return npclist;
        }
        for (int i = 0; i < info.num; ++i) {
            NPC mapnpc = null;
            mapnpc = info.npckey != 0L && info.num == 1 ? this.createNpc(info.npcbaseid, info.name, 0, info.npckey) : this.createNpc(info.npcbaseid, info.name, 0);
            mapnpc.setShape(info.shape);
            GridPos pos = null;
            pos = info.posx == 0 || info.posy == 0 ? MapUtil.genPosInMap((long)s.getSceneID()) : new GridPos(info.posx, info.posy);
            if (!this.summonNpc((Scene)s, pos.toPosition(), mapnpc)) {
                for (NpcInfo remove : npclist) {
                    SceneNpcManager.getInstance().removeNpcFromScene(remove.npckey, "SceneNpcManager.createNpc");
                }
                return npclist;
            }
            NpcInfo npcinfo = new NpcInfo(mapnpc.getUniqueID(), mapnpc.getNpcID(), mapnpc.getName(), mapnpc.getShape(), s.getSceneID(), info.mapid, s.getName(), pos.toPosition().getX(), pos.toPosition().getY(), pos.toPosition().getZ(), info.time);
            npclist.add(npcinfo);
        }
        return npclist;
    }
}

